package yonyou.udh.demo;

import java.util.LinkedList;

import org.apache.spark.api.java.*;
import org.apache.spark.api.java.function.Function;
import org.apache.spark.mllib.linalg.distributed.RowMatrix;
import org.apache.spark.mllib.linalg.Matrix;
import org.apache.spark.mllib.linalg.Vector;
import org.apache.spark.mllib.linalg.Vectors;
import org.apache.spark.rdd.RDD;
import org.apache.spark.SparkConf;
import org.apache.spark.SparkContext;

public class PCA {
  public static void main(String[] args) {
    SparkConf conf = new SparkConf().setAppName("PCA Example");
    JavaSparkContext sc = new JavaSparkContext(conf);
    
    String path = "hdfs://udh-spark-01:8020/tmp/mllib/dr.txt";
    JavaRDD<String> data = sc.textFile(path);
    
    JavaRDD<Vector> parsedData = data.map(
    	      new Function<String, Vector>() {
    	        public Vector call(String s) {
    	          String[] sarray = s.split(" ");
    	          double[] values = new double[sarray.length];
    	          for (int i = 0; i < sarray.length; i++)
    	            values[i] = Double.parseDouble(sarray[i]);
    	          return Vectors.dense(values);
    	        }
    	      }
    );

    // Create a RowMatrix from JavaRDD<Vector>.
    RowMatrix mat = new RowMatrix(parsedData.rdd());

    // Compute the top 3 principal components.
    Matrix pc = mat.computePrincipalComponents(3);
    RowMatrix projected = mat.multiply(pc);
    
    System.out.println("---------------------begin--------------------------");
    System.out.println("Matrix pc =" + pc+" NUM ROWS="+pc.numRows()+" NUM COLS="+pc.numCols());
    System.out.println("RowMatrix projected ="+projected+ " NUM ROWS="+projected.numRows()+" NUM COLS="+projected.numCols());
    System.out.println("---------------------end--------------------------");
    sc.stop();
  }
}
